/*******************************************************************************
 * Size: 20 px
 * Bpp: 2
 * Opts:
 ******************************************************************************/

#ifdef LV_LVGL_H_INCLUDE_SIMPLE
#include "lvgl.h"
#else
#include "lvgl/lvgl.h"
#endif

#ifndef SYMBOL_CUSTOM
#define SYMBOL_CUSTOM 1
#endif

#if SYMBOL_CUSTOM

/*-----------------
 *    BITMAPS
 *----------------*/

/*Store the image of the glyphs*/
static LV_ATTRIBUTE_LARGE_CONST const uint8_t glyph_bitmap[] = {
    /* U+F017 "" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xff,
    0x90, 0x0, 0x0, 0x7f, 0xff, 0xfc, 0x0, 0x2,
    0xff, 0xff, 0xff, 0x40, 0xb, 0xff, 0xeb, 0xff,
    0xc0, 0x1f, 0xff, 0x43, 0xff, 0xf0, 0x3f, 0xff,
    0x43, 0xff, 0xf4, 0x7f, 0xff, 0x43, 0xff, 0xfc,
    0xbf, 0xff, 0x43, 0xff, 0xfc, 0xff, 0xff, 0x43,
    0xff, 0xfd, 0xff, 0xff, 0x43, 0xff, 0xfd, 0xff,
    0xff, 0x40, 0xbf, 0xfd, 0xbf, 0xff, 0xc0, 0x1f,
    0xfc, 0x7f, 0xff, 0xf4, 0x2f, 0xfc, 0x3f, 0xff,
    0xfe, 0xbf, 0xf8, 0x2f, 0xff, 0xff, 0xff, 0xf0,
    0xf, 0xff, 0xff, 0xff, 0xd0, 0x3, 0xff, 0xff,
    0xff, 0x80, 0x0, 0xff, 0xff, 0xfd, 0x0, 0x0,
    0x1f, 0xff, 0xe0, 0x0, 0x0, 0x0, 0x14, 0x0,
    0x0,

    /* U+F086 "" */
    0x0, 0x0, 0x54, 0x0, 0x0, 0x0, 0x0, 0x2f,
    0xff, 0xd0, 0x0, 0x0, 0x2, 0xff, 0xff, 0xf8,
    0x0, 0x0, 0xb, 0xff, 0xff, 0xff, 0x0, 0x0,
    0x1f, 0xff, 0xff, 0xff, 0x80, 0x0, 0x3f, 0xff,
    0xff, 0xff, 0xc0, 0x0, 0x3f, 0xff, 0xff, 0xff,
    0xc5, 0x0, 0x3f, 0xff, 0xff, 0xff, 0xcb, 0xc0,
    0x2f, 0xff, 0xff, 0xff, 0xcb, 0xf0, 0xf, 0xff,
    0xff, 0xff, 0x4f, 0xfc, 0xb, 0xff, 0xff, 0xfe,
    0x2f, 0xfd, 0xf, 0xff, 0xff, 0xf8, 0xbf, 0xfd,
    0x3e, 0x5f, 0xff, 0x82, 0xff, 0xfd, 0x0, 0x0,
    0x0, 0x1f, 0xff, 0xfc, 0x0, 0x0, 0xab, 0xff,
    0xff, 0xf8, 0x0, 0x0, 0x7f, 0xff, 0xff, 0xf0,
    0x0, 0x0, 0xf, 0xff, 0xff, 0xf8, 0x0, 0x0,
    0x1, 0xbf, 0xf9, 0x7d, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0,

    /* U+F0E8 "" */
    0x0, 0x0, 0x5, 0x54, 0x0, 0x0, 0x0, 0x0,
    0xf, 0xff, 0xd0, 0x0, 0x0, 0x0, 0x3, 0xff,
    0xf4, 0x0, 0x0, 0x0, 0x0, 0xff, 0xfd, 0x0,
    0x0, 0x0, 0x0, 0x3f, 0xff, 0x40, 0x0, 0x0,
    0x0, 0xf, 0xff, 0xd0, 0x0, 0x0, 0x0, 0x2,
    0xff, 0xf0, 0x0, 0x0, 0x0, 0x0, 0x7, 0x80,
    0x0, 0x0, 0x0, 0x0, 0x1, 0xe0, 0x0, 0x0,
    0x0, 0xff, 0xff, 0xff, 0xff, 0xfc, 0x0, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xc0, 0x3c, 0x0, 0x7,
    0x80, 0x0, 0xf0, 0xb, 0x0, 0x0, 0xe0, 0x0,
    0x38, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xb,
    0xff, 0x0, 0xff, 0xd0, 0x3f, 0xfb, 0xff, 0xc0,
    0x7f, 0xfc, 0xf, 0xff, 0xff, 0xf4, 0x1f, 0xff,
    0x7, 0xff, 0xff, 0xfd, 0x7, 0xff, 0xc1, 0xff,
    0xff, 0xff, 0x41, 0xff, 0xf0, 0x7f, 0xff, 0xff,
    0xc0, 0x7f, 0xf8, 0xf, 0xff, 0x15, 0x40, 0x1,
    0x54, 0x0, 0x55, 0x0,

    /* U+F0EB "" */
    0x0, 0x15, 0x40, 0x0, 0x2f, 0xff, 0x40, 0xf,
    0xff, 0xfe, 0x3, 0xf8, 0x2f, 0xf8, 0x7e, 0x2f,
    0xff, 0xcb, 0xcb, 0xff, 0xfd, 0xf8, 0xff, 0xff,
    0xef, 0xaf, 0xff, 0xfe, 0xff, 0xff, 0xff, 0xeb,
    0xff, 0xff, 0xfd, 0x3f, 0xff, 0xff, 0xc1, 0xff,
    0xff, 0xf0, 0xb, 0xff, 0xfd, 0x0, 0x3f, 0xff,
    0xc0, 0x2, 0xff, 0xf4, 0x0, 0x5, 0x55, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x1f, 0xff, 0x0, 0x0,
    0xff, 0xf0, 0x0, 0xf, 0xfe, 0x0, 0x0, 0x2a,
    0x80, 0x0,

    /* U+F108 "" */
    0x1a, 0xaa, 0xaa, 0xaa, 0xaa, 0x42, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xcf, 0xff, 0xff, 0xff, 0xff,
    0xff, 0x7e, 0x0, 0x0, 0x0, 0x0, 0x3e, 0xf8,
    0x0, 0x0, 0x0, 0x0, 0xfb, 0xe0, 0x0, 0x0,
    0x0, 0x3, 0xef, 0x80, 0x0, 0x0, 0x0, 0xf,
    0xbe, 0x0, 0x0, 0x0, 0x0, 0x3e, 0xf8, 0x0,
    0x0, 0x0, 0x0, 0xfb, 0xe0, 0x0, 0x0, 0x0,
    0x3, 0xef, 0x80, 0x0, 0x0, 0x0, 0xf, 0xbe,
    0x0, 0x0, 0x0, 0x0, 0x3e, 0xf8, 0x0, 0x0,
    0x0, 0x0, 0xfb, 0xe0, 0x0, 0x0, 0x0, 0x3,
    0xef, 0xea, 0xaa, 0xaa, 0xaa, 0xaf, 0xbf, 0xff,
    0xff, 0xff, 0xff, 0xfd, 0x7f, 0xff, 0xff, 0xff,
    0xff, 0xe0, 0x0, 0x0, 0xff, 0x40, 0x0, 0x0,
    0x0, 0x7, 0xfe, 0x0, 0x0, 0x0, 0xf, 0xff,
    0xff, 0xf4, 0x0, 0x0, 0x2a, 0xaa, 0xaa, 0x80,
    0x0,

    /* U+F188 "" */
    0x0, 0x0, 0x14, 0x0, 0x0, 0x0, 0x2, 0xff,
    0x80, 0x0, 0x0, 0xb, 0xff, 0xe0, 0x0, 0x0,
    0xf, 0xff, 0xf0, 0x0, 0x19, 0x1f, 0xff, 0xf4,
    0x60, 0x2f, 0x40, 0x0, 0x1, 0xf8, 0xf, 0xe5,
    0x55, 0x5b, 0xf0, 0x3, 0xff, 0xff, 0xff, 0xc0,
    0x2, 0xff, 0xff, 0xff, 0x80, 0x2, 0xff, 0xc3,
    0xff, 0x80, 0x1b, 0xff, 0xc3, 0xff, 0xe4, 0xff,
    0xff, 0xc3, 0xff, 0xff, 0xbf, 0xff, 0xc3, 0xff,
    0xfe, 0x2, 0xff, 0xc3, 0xff, 0x80, 0x1, 0xff,
    0xc3, 0xff, 0x40, 0x0, 0xff, 0xc3, 0xff, 0x0,
    0x2, 0xff, 0xc3, 0xff, 0x80, 0xb, 0xff, 0xc3,
    0xff, 0xe0, 0x1f, 0xc7, 0xc3, 0xd3, 0xf4, 0x2f,
    0x0, 0x0, 0x0, 0xf8, 0x4, 0x0, 0x0, 0x0,
    0x10,

    /* U+F233 "" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0xbf, 0xff, 0xff,
    0xff, 0xfe, 0xff, 0xff, 0xff, 0xfb, 0xbf, 0xff,
    0xff, 0xff, 0xe3, 0x1f, 0xff, 0xff, 0xff, 0xff,
    0xff, 0x6a, 0xaa, 0xaa, 0xaa, 0xa9, 0x0, 0x0,
    0x0, 0x0, 0x0, 0xbf, 0xff, 0xff, 0xff, 0xfe,
    0xff, 0xff, 0xff, 0xfb, 0xbf, 0xff, 0xff, 0xff,
    0xd2, 0xf, 0xff, 0xff, 0xff, 0xfb, 0xbf, 0xbf,
    0xff, 0xff, 0xff, 0xfe, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x6a, 0xaa, 0xaa, 0xaa, 0xa9, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xe3, 0x1f,
    0xff, 0xff, 0xff, 0xfb, 0xbf, 0xbf, 0xff, 0xff,
    0xff, 0xfe, 0x0, 0x0, 0x0, 0x0, 0x0,

    /* U+F796 "" */
    0x0, 0x3f, 0xff, 0xfc, 0x0, 0x0, 0x3f, 0xff,
    0xfc, 0x0, 0x1, 0xbf, 0xff, 0xfe, 0x40, 0x7,
    0xff, 0xff, 0xff, 0xd0, 0xb, 0xff, 0xff, 0xff,
    0xe0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0x3e, 0x3d, 0xbc, 0xff, 0xff,
    0x3e, 0x3d, 0xbc, 0xff, 0xff, 0x3e, 0x3d, 0xbc,
    0xff, 0xff, 0x3e, 0x3d, 0xbc, 0xff, 0xff, 0x3e,
    0x3d, 0xbc, 0xff,

    /* U+F7C0 "" */
    0x0, 0x0, 0x14, 0x0, 0x0, 0x0, 0x0, 0x1f,
    0xf4, 0x0, 0x0, 0x0, 0x7, 0xff, 0xd0, 0x0,
    0x0, 0x0, 0x7, 0xfe, 0x0, 0x0, 0x0, 0x68,
    0x1f, 0xe0, 0x0, 0x0, 0x2f, 0xf0, 0xfd, 0x0,
    0x0, 0x7, 0xff, 0x4f, 0xc0, 0x0, 0x0, 0x7,
    0xf4, 0xf8, 0x4, 0x0, 0x0, 0x3f, 0x2f, 0x7,
    0xc0, 0x0, 0x7, 0xe3, 0xe3, 0xfc, 0x1, 0x0,
    0xbc, 0xf8, 0xff, 0xc1, 0xf0, 0x1f, 0x2f, 0x3f,
    0xfc, 0xf8, 0x3, 0xc7, 0xcf, 0xff, 0xf0, 0x0,
    0x0, 0x2, 0xff, 0xfc, 0x0, 0x0, 0x0, 0x7f,
    0xff, 0xc0, 0x0, 0x0, 0xf, 0xff, 0xfc, 0x0,
    0x0, 0x0, 0xff, 0xff, 0xc0, 0x0, 0x0, 0x1f,
    0xff, 0xfc, 0x0, 0x0, 0x0, 0xbf, 0xfe, 0x0,
    0x0, 0x0, 0x1, 0x54, 0x0, 0x0, 0x0
};


/*---------------------
 *  GLYPH DESCRIPTION
 *--------------------*/

static const lv_font_fmt_txt_glyph_dsc_t glyph_dsc[] = {
    {.bitmap_index = 0, .adv_w = 0, .box_w = 0, .box_h = 0, .ofs_x = 0, .ofs_y = 0} /* id = 0 reserved */,
    {.bitmap_index = 0, .adv_w = 320, .box_w = 20, .box_h = 21, .ofs_x = 0, .ofs_y = -3},
    {.bitmap_index = 105, .adv_w = 360, .box_w = 24, .box_h = 19, .ofs_x = -1, .ofs_y = -2},
    {.bitmap_index = 219, .adv_w = 400, .box_w = 25, .box_h = 21, .ofs_x = 0, .ofs_y = -3},
    {.bitmap_index = 351, .adv_w = 220, .box_w = 14, .box_h = 21, .ofs_x = 0, .ofs_y = -3},
    {.bitmap_index = 425, .adv_w = 360, .box_w = 23, .box_h = 21, .ofs_x = 0, .ofs_y = -3},
    {.bitmap_index = 546, .adv_w = 320, .box_w = 20, .box_h = 21, .ofs_x = 0, .ofs_y = -3},
    {.bitmap_index = 651, .adv_w = 320, .box_w = 20, .box_h = 19, .ofs_x = 0, .ofs_y = -2},
    {.bitmap_index = 746, .adv_w = 320, .box_w = 20, .box_h = 15, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 821, .adv_w = 320, .box_w = 21, .box_h = 21, .ofs_x = -1, .ofs_y = -3}
};

/*---------------------
 *  CHARACTER MAPPING
 *--------------------*/

static const uint16_t unicode_list_0[] = {
    0x0, 0x6f, 0xd1, 0xd4, 0xf1, 0x171, 0x21c, 0x77f,
    0x7a9
};

/*Collect the unicode lists and glyph_id offsets*/
static const lv_font_fmt_txt_cmap_t cmaps[] =
{
    {
        .range_start = 61463, .range_length = 1962, .glyph_id_start = 1,
        .unicode_list = unicode_list_0, .glyph_id_ofs_list = NULL, .list_length = 9, .type = LV_FONT_FMT_TXT_CMAP_SPARSE_TINY
    }
};



/*--------------------
 *  ALL CUSTOM DATA
 *--------------------*/

#if LV_VERSION_CHECK(8, 0, 0)
/*Store all the custom data of the font*/
static  lv_font_fmt_txt_glyph_cache_t cache;
static const lv_font_fmt_txt_dsc_t font_dsc = {
#else
static lv_font_fmt_txt_dsc_t font_dsc = {
#endif
    .glyph_bitmap = glyph_bitmap,
    .glyph_dsc = glyph_dsc,
    .cmaps = cmaps,
    .kern_dsc = NULL,
    .kern_scale = 0,
    .cmap_num = 1,
    .bpp = 2,
    .kern_classes = 0,
    .bitmap_format = 0,
#if LV_VERSION_CHECK(8, 0, 0)
    .cache = &cache
#endif
};


/*-----------------
 *  PUBLIC FONT
 *----------------*/

/*Initialize a public general font descriptor*/
#if LV_VERSION_CHECK(8, 0, 0)
const lv_font_t symbol_custom = {
    .fallback = LV_FONT_DEFAULT,
#else
lv_font_t symbol_custom = {
#endif
    .get_glyph_dsc = lv_font_get_glyph_dsc_fmt_txt,    /*Function pointer to get glyph's data*/
    .get_glyph_bitmap = lv_font_get_bitmap_fmt_txt,    /*Function pointer to get glyph's bitmap*/
    .line_height = 21,          /*The maximum line height required by the font*/
    .base_line = 3,             /*Baseline measured from the bottom of the line*/
#if !(LVGL_VERSION_MAJOR == 6 && LVGL_VERSION_MINOR == 0)
    .subpx = LV_FONT_SUBPX_NONE,
#endif
#if LV_VERSION_CHECK(7, 4, 0) || LVGL_VERSION_MAJOR >= 8
    .underline_position = -7,
    .underline_thickness = 1,
#endif
    .dsc = &font_dsc           /*The custom font data. Will be accessed by `get_glyph_bitmap/dsc` */
};



#endif /*#if SYMBOL_CUSTOM*/

